/**	\file SimpleType.h
 **	\date  2008-05-26
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2008-2009  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _SimpleType_H
#define _SimpleType_H

#include <string>
#include <list>
#include "TypeBase.h"


class Wsdl;

class SimpleType : public TypeBase
{
public:
	SimpleType(const Wsdl& wsdl, const XmlNode& node, const std::string& name = "", const std::string& ns_prefix = "");
	~SimpleType();

	const std::string& Name() const { return m_name; }
	const std::string Documentation() const;

	void CreateInterface(FILE *fil, int lvl = 1) const;

	const std::string CType() const;

private:
	std::string m_name;
	std::list<std::pair<std::string, std::string> > m_enum;
};




#endif // _SimpleType_H
