/**	\file TypeBase.h
 **	\date  2008-05-26
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2008-2009  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _TypeBase_H
#define _TypeBase_H

#include <string>


class Wsdl;
class XmlNode;

typedef enum {
	T_UNKNOWN = 0,
	T_STRING,
	T_NUMBER,
	T_BOOLEAN, T_COMPLEX } type_t;

class TypeBase
{
public:
	TypeBase(const Wsdl& wsdl, const XmlNode& node, const std::string& ns_prefix, const std::string& type);
	~TypeBase();

	const std::string& Type() const { return m_type; }
	const std::string Documentation(const XmlNode& ) const;
	const std::string CType() const;

	const std::string& NsHref() const { return m_ns_href; }

	void SetType(const std::string& x);

	bool IsBuiltin() const;
	type_t TypeClass() const { return m_t_type; }

protected:
	const Wsdl& m_wsdl;
	const XmlNode& m_node;
	std::string m_ns_href;
	std::string m_type;
	type_t m_t_type;
	std::string m_c_type;

private:
	void SetCType();
};




#endif // _TypeBase_H
